import numpy as np
import sys,os

import matplotlib as mpl
mpl.use('Agg')
import matplotlib.pyplot as plt

n_sample = int(sys.argv[1]) #10000 (number of instances per task)
n_task = int(sys.argv[2]) #100 (number of tasks)
I = int(sys.argv[3]) #1 (number of experiments)
low = -1
n_hidden = 5
n_out = 1
scale = 1e-2

od = "data/synth_curth_s%st%sI%s"%(n_sample,n_task,I)
os = os.makedirs(od,exist_ok=True)

n_c = 5
n_o = 5
n_co = n_c+n_o
xi = 3
n_t = 5
n_att = 25

def sigmoid(x):
    return 1/(1+np.exp(-x))

for i in range(I):
    x = np.random.normal(size=(n_task,n_sample,n_att))

    if n_task == 1:
        w_mu0 = np.ones((n_task,1,n_co))
        w_pi = np.ones((n_task,1,n_c))
        w_mu1 = np.ones((n_task,1,n_t))
        
    else:
        w_mu0 = np.random.uniform(low=low,high=1,size=(n_task,1,n_co))
        w_pi = np.random.uniform(low=low,high=1,size=(n_task,1,n_c))
        w_mu1 = np.random.uniform(low=low,high=1,size=(n_task,1,n_t))

    mu0 = np.zeros((n_task,n_sample,1))
    mu1 = np.zeros((n_task,n_sample,1))
    pi = np.zeros((n_task,n_sample,1))
    for j in range(n_task):
        perm = np.random.permutation(n_att)
        mu0[j,:,:] = np.sum((w_mu0[j,:,:]*(x[j,:,:][:,perm[:n_co]]**2)),1,keepdims=True)
        pi[j,:,:] = np.sum((w_pi[j,:,:]*(x[j,:,:][:,perm[:n_c]]**2)),1,keepdims=True)
        pi[j,:,:] = sigmoid(xi*(pi[j,:,:]-np.median(pi[j,:,:],0,keepdims=True)))
        mu1[j,:,:] = mu0[j,:,:]+np.sum((w_mu1[j,:,:]*(x[j,:,:][:,perm[n_co:n_co+n_t]]**2)),1,keepdims=True)

    a = np.random.binomial(1,pi)
    y = a*mu1+(1-a)*mu0+np.random.randn(n_task,n_sample,1)
    tau = mu1-mu0
    mu = np.concatenate((mu0,mu1),-1)
    ofn = "%s/i%s.npz"%(od,i)
    print(ofn)


    is_plot = 0
    if is_plot == 1:
        for k in range(n_att):
            for j in range(n_task):
                pfn = "%s/plot_pi_i%sj%sx%s.png"%(od,i,j,k)
                plt.clf()
                plt.plot(x[j,:,k],pi[j,:,0],'.')
                plt.savefig(pfn)

            for j in range(n_task):
                pfn = "%s/plot_tau_i%sj%sx%s.png"%(od,i,j,k)
                plt.clf()
                plt.plot(x[j,:,k],tau[j,:,0],'.')
                plt.savefig(pfn)

            for j in range(n_task):
                pfn = "%s/plot_mu0_i%sj%sx%s.png"%(od,i,j,k)
                plt.clf()
                plt.plot(x[j,:,k],mu0[j,:,0],'.')
                print(pfn)
                plt.savefig(pfn)
            for j in range(n_task):
                pfn = "%s/plot_mu1_i%sj%sx%s.png"%(od,i,j,k)
                plt.clf()
                plt.plot(x[j,:,k],mu1[j,:,0],'.')
                plt.savefig(pfn)
            for j in range(n_task):
                pfn = "%s/plot_y_i%sj%sx%s.png"%(od,i,j,k)
                plt.clf()
                plt.plot(x[j,:,k],y[j,:,0],'.')
                plt.savefig(pfn)                

    np.savez(ofn,x=x,y=y,a=a,mu=mu,tau=tau)

